ext @Temp@Byte
ext @Temp@Word
ext @Temp@Word2

@Temp@WordH equ @Temp@Word
@Temp@WordL equ @Temp@Word+1
@Temp@Word2H equ @Temp@Word2
@Temp@Word2L equ @Temp@Word2+1

cseg

tempo equ 220

dseg
cycle defw 0
cycle_Hi equ cycle
cycle_Lo equ cycle+1

cseg
Tone:
; in:
;   b: length
    psha
        clr $c80d
        ldaa #$e0
        staa $c80b
        
        stab $c808
        clr $c809

        ldaa cycle_Lo
        staa $c804
        ldaa cycle_Hi
        staa $c805

        do 
            ldaa $c80d
            bita #$20
        while eq | wend
        ldaa #$20
        staa $c80b
    pula
rts

Sound_Get_:
    public Sound_Get_
    psha
        ldx #$3fc
        stx cycle
        ldab #20
        bsr Tone
    pula
rts


Sound_Hit_:
    public Sound_Hit_
    psha
    pshb
        ldx #2000
        stx cycle
        ldab #20
        do
            pshb
                ldab #2
                bsr Tone
                ldaa cycle_Lo
                suba #50
                staa cycle_lo
                ldaa cycle_hi
                sbca #0
                staa cycle_hi    
            pulb
            decb
        while ne | wend
    pulb
    pula
rts

; Sound_Miss_:
;     public Sound_Miss_
;     psha
;     pshb
;         ldx #1000
;         stx cycle
;         ldab #20
;         do
;             pshb
;                 ldab #2
;                 bsr Tone
;                 ldaa cycle_Lo
;                 adda #50
;                 staa cycle_lo
;                 ldaa cycle_hi
;                 adca #0
;                 staa cycle_hi    
;             pulb
;             decb
;         while ne | wend
;     pulb
;     pula
; rts


Sound_Loose_:
    public Sound_Loose_
    psha
    pshb
        ldx #6000
        stx cycle
        ldab #8
        bsr Tone
    pulb
    pula
rts


Melody:
    ldaa #$e0
    staa $c80b

    stx @Temp@Word
    do
        ldx @Temp@Word
        ldab 0,x
    while ne
        inx
        ldaa 0,x
        asla
        adda 0,x
        inx
        stx @Temp@Word
        
        ldx #cycles
        stx @Temp@Word2
        adda @Temp@Word2L
        staa @Temp@Word2L
        ldaa @Temp@Word2H
        adca #0
        staa @Temp@Word2H
        ldx @Temp@Word2

        ldaa 1,x
        staa $c804
        ldaa 0,x
        staa $c805

        do
            clr $c80d
            ldaa 2,x
            staa $c808
            clr $c809
            do 
                ldaa $c80d
                bita #$20
            while eq | wend
            decb
        while ne | wend
    wend

        ldaa #$20
        staa $c80b
rts

C4 equ 0
D4 equ 2
E4 equ 4
F4 equ 6
G4 equ 7
A4 equ 9
B4 equ 11
C5 equ 12

start_notes: defb 3,C4, 3,G4, 3,E4, 3,G4, 12,C5, 0
Sound_Start_: 
    public Sound_Start_
    psha 
    pshb
        ldx #start_notes
        bsr Melody
    pulb
    pula
rts


clear_notes: defb 3,C4, 3,E4, 3,G4, 3,D4, 3,F4, 3,A4, 3,E4, 3,G4, 3,B4, 9,C5,0
Sound_Clear_:
    public Sound_Clear_
    psha 
    pshb
        ldx #clear_notes
        bsr Melody
    pulb
    pula
rts


over_notes: defb 3,C5, 3,G4, 3,E4, 3,C5,  3,B4, 3,G4, 3,E4, 3,B4,  6,A4, 6,B4,  12,C5, 0
Sound_GameOver_: public Sound_GameOver_
    psha 
    pshb
        ldx #over_notes
        bsr Melody
    pulb
    pula
rts


cycles: public cycles
defw 1713 | defb 2616/tempo ;C4
defw 1617 | defb 2771/tempo ;C#4
defw 1527 | defb 2936/tempo ;D4
defw 1441 | defb 3111/tempo ;D#4
defw 1360 | defb 3296/tempo ;E4
defw 1284 | defb 3492/tempo ;F
defw 1212 | defb 3699/tempo ;F#4
defw 1144 | defb 3919/tempo ;G4
defw 1080 | defb 4153/tempo ;G#4
defw 1020 | defb 4400/tempo ;A4
defw 963 | defb 4661/tempo ;A#4
defw 909 | defb 4938/tempo ;B4
defw 858 | defb 5232/tempo ;C5

