#include "Status.h"
#include "Vram.h"
#include "Main.h"
#include "Chars.h"
#include "Print.h"
#include "Knife.h"

static ptr<byte> PrintS(ptr<byte> pVram, ptr<byte> p)
{
    byte c;
    while ((c = *p) != 0) {
        pVram = PrintC(pVram, c);
        ++p;
    }
    return pVram;
}

void PrintStatus() 
{
    PrintS(Vram + VramRowSize * 0 + 24, "SCORE"); 
    PrintS(Vram + VramRowSize * 5 + 24, "HI-SCORE");
    PrintS(Vram + VramRowSize * 10 + 24, "STAGE");
    PrintByteNumber2(Vram + VramRowSize * 10 + 30, CurrentStage + 1);
    PrintS(Vram + VramRowSize * 13 + 24, "TIME");
    {
        constexpr ptr<byte> RemainLeft = Vram + VramRowSize * 19 + 25;
        ptr<byte> pVram;
        byte count;
        pVram = RemainLeft;
        for (count = 1; count < RemainCount; ++count) {
            pVram = Put2(pVram, Char_Remain);
        }
    }

    PrintScore();
    PrintTime();
    PrintHeldKnives();
}

void PrintScore()
{
    ptr<byte> pVram;
    
    pVram = PrintNumber5(Vram + VramRowSize * 2 + 26, Score);
    PrintC(pVram, '0');

    pVram = PrintNumber5(Vram + VramRowSize * 7 + 26, HiScore);
    PrintC(pVram, '0');
}

void PrintTime()
{
    PrintNumber3(Vram + VramRowSize * 13 + 29, StageTime);
}

void PrintHeldKnives()
{
    ptr<byte> pVram;
    byte count, i;

    pVram = Vram + VramRowSize * 17 + 25;
    i = 0;
    count = HeldKnifeCount;
    while (count != 0) {
        *pVram = Char_Kn_Left; ++pVram;
        ++i;
        --count;
    }
    while (i != 4) {
        *pVram = Char_Space; ++pVram;
        ++i;
    }
}

void PrintGameOver()
{
    PrintS(Vram + VramRowSize * 11 + 12, "GAME OVER");
}

void PrintTimeUp() 
{
    PrintS(Vram + VramRowSize * 11 + 13, "TIME UP");
}

void Title()
{
    ClearScreen(); 
    {
        static const byte[] TitleBytes = {
            0x68,0x64,0x64,0x63, 0x68,0x72,0x72,0x4E, 0x68,0x72,0x72,0x4E, 0x7A,0x78,0x78,0x6E,
            0x00,0x76,0x66,0x73, 0x68,0x72,0x00,0x4E, 0x68,0x64,0x6E,0x4E, 0x7A,0x78,0x00,0x6E,
            0x7A,0x6E,0x66,0x64, 0x00,0x61,0x64,0x00, 0x61,0x64,0x00,0x00, 0x7A,0x6E,0x6E,0x6E,
            0x68,0x72,0x68,0x72, 0x7A,0x63,0x76,0x78, 0x00,0x68,0x72,0x00, 0x00,0x7A,0x78,0x00,
        };
        ptr<byte> p;
        ptr<byte> pVram;
        pVram = Vram + VramRowSize * 1 + 4;
        p = TitleBytes;
        repeat (4) {
            repeat (4) {
                repeat (4) {
                    *pVram = *p;
                    ++pVram;
                    ++p;
                }
                pVram += VramRowSize - 4;
            }
            pVram += 4 - VramRowSize * 4;
        }
    }
    Put2(Vram + VramRowSize * 8 + 6, Char_Remain);
    Put2(Vram + VramRowSize * 10 + 6, Char_Chaser);
    Put2(Vram + VramRowSize * 12 + 6, Char_Disturber);
    Put2(Vram + VramRowSize * 14 + 6, Char_Goal);
    
    PrintStatus(); 
    PrintS(Vram + VramRowSize * 6 + 4, "--- CHARACTER ---");
    PrintS(Vram + VramRowSize * 9 + 10, "MAN");
    PrintS(Vram + VramRowSize * 11 + 10, "CHASER");
    PrintS(Vram + VramRowSize * 13 + 10, "DISTURBER");
    PrintS(Vram + VramRowSize * 15 + 10, "EXIT");

    PrintS(Vram + VramRowSize * 20 + 5, "PUSH 'Z' KEY");
}
